<?php
include_once("ckb/db/mysql-queries.php");
//set up connection to scheduler table


function schedule_process ($name, $time = 0, $new = true)
//Schedule Process Function
{
	if (empty($time)|| is_null($time)) $time= time();
		$proc = new process($name);
	if ($proc->vals)
	{
	file_put_contents('cron.log', 'process schedule'. date('Y-m-d H:i:s',time()) . PHP_EOL,FILE_APPEND );
		$proc->schedule($time,$new);

	}
}


function reschedule_process ($name, $time = 0, $new = false)
//Schedule Process Function
{
	if (empty($time)|| is_null($time)) $time= time();
		$proc = new process($name);
	if ($proc->vals)
	{
	file_put_contents('cron.log', 'process reschedule'. date('Y-m-d H:i:s',$time) . PHP_EOL,FILE_APPEND );
		$proc->schedule($time,$new);
	}
}

function schedule_delete ($name)
//Schedule Process Func
{
	$proc = new process($name);
	if ($proc->vals)
	{
		file_put_contents('cron.log', 'process delete'. date('Y-m-d H:i:s',time()) . PHP_EOL,FILE_APPEND );
		$sched = new schedule();
		$sched->delete($name);
	}
}

class process
{
	public $vals = false;
	public $schedule = null;

	function __construct($name)
	{
	/******
	Select the data from db for this process
	*******/
		$this->vals = mysqlselect1('SELECT * FROM mm_process WHERE code = "'.$name.'"');
	}

	function schedule($time=false, $new = false)
	/***********************
	Schedules job - currently they are unique in that the same job cannot be scheduled twice
	***********************/
	{
		if (!$time) $time = time();
		if (is_null($time)) $time = time();
		if (empty($time)) $time = time();

		$action = 0; // just
		$uid = false;
		$PID =   false;
		$job = new execute();
		$res1 = mysqlselect1('SELECT * FROM mm_schedule WHERE ref1 = '.$this->vals['uid']);
		if ($res1)
		{
			$uid = $res1['uid'];
			$PID = $res1['ref2'];
			if ($new)
			{
				if ($res1['status'] == 1)
				{
					if ($job->is_running($res1['ref2']))
					{
						$PID = false;
						$action = 1;
					}
				}
			}
			else
			{
				$action = 0;
			}
		}

		$sched = new schedule();
		$this->schedule = array();
		$this->schedule['ref1'] = $this->vals['uid'];
//		$this->schedule['ref2'] = 'NULL';
		$this->schedule['status'] = 0;
		$this->schedule['code'] = $this->vals['code'];
		$this->schedule['value'] = $time;
		$this->schedule['body'] = $this->setcommand();

		if ($action == 1)
		// RETAIN RUNNING UPDATE ONLY TIME VALUE TO NOW
		{

			$res1=mysqlupdate('UPDATE mm_schedule SET value ="'.time().'" WHERE uid  = '.$uid);
		}
		if ($action == 0)
		{
			$res1=mysqldelete('DELETE FROM mm_schedule WHERE ref1 = '. $this->schedule['ref1']);
			$this->schedule['uid'] = mysqlinsert('INSERT INTO mm_schedule (ref1,code,value,body) VALUES ('.$this->schedule['ref1'].',"'.$this->schedule['code'].'","'.$this->schedule['value'].'","'.$this->schedule['body'].'")');
			if ($this->schedule['value'] <= time())
					$res1 = $sched->runprocess($job,$this->schedule);
			if ($PID) $job->kill($PID);
		}
	}

	function setcommand()
	{
	// This will become a construction using context and input now it transfers process body across
		return $this->vals['body'];
	}
}

class schedule
{
/************
Status 0 - Scheduled, 1 - Running, 2 - Closing, 4 - Closed, 5 - Suspended, 6 - Delete
************/

	function __construct()
	{
		$this->clean();
	}

	function clean()
	{
	/*****************
	The process will clean themselves. Here we make vsure things marked as deleted are deleted cleanly;
	******************/
		$res1 = mysqlselect1('SELECT * FROM mm_schedule WHERE  status = 2');
		if ($res1)
		{
			$job = new execute();
			foreach	($res1 as $rec)
				if (!is_null($rec['ref2'])) $job->kill($rec['ref2']);
		}
		$res1 = mysqldelete('DELETE FROM mm_schedule WHERE  status = 2');
	}

	function execute()
	{
		$job = new execute();
		$next = false;
		$res1=mysqlselectn('SELECT * FROM mm_schedule WHERE status=0');
		if ($res1)
			foreach($res1 as $rec)
			{
				$schedtime = (int)$rec['value'];
				if ($schedtime <= time()) $this->runprocess($job,$rec);
				else
				{
					if (!$next)
						$next = $schedtime;
					else
						if ($schedtime < $next) $next = $schedtime;
				}
				/**********
				$next is used for 'sub scheduling' cron!.
				**********/
			}
		return $next;
	}

	function delete($name)
	{

	$res1=mysqlupdate('UPDATE mm_schedule SET status = 2 WHERE code = "'.$name.'"');

		$this->clean();
	}


    function runprocess($job,$rec)
	{
		$PID = $job->background($rec['body']);
		if ($PID)
			$res1 = mysqlupdate('UPDATE mm_schedule SET status = 1, ref2 = '.$PID. ' WHERE uid = '.$rec['uid']);
	file_put_contents('cron.log', 'run process '. date('Y-m-d H:i:s',time()) . PHP_EOL,FILE_APPEND );
	}
}


class execute
{
/**
 * Run Application in background
 *
 * @param     unknown_type $Command
 * @param     unknown_type $Priority
 * @return     PID
 */
    function background($Command, $Priority = 0)
    {
       if($Priority)
           $PID = shell_exec("nohup nice -n $Priority $Command > /dev/null & echo $!");
       else
           $PID = shell_exec("nohup $Command > /dev/null & echo $!");
       return($PID);
   	}
   	function is_running($PID)
   	/**
	* Check if the Application running !
	*
	* @param     unknown_type $PID
	* @return     boolen
	*/
   	{
   	    exec("ps $PID", $ProcessState);
   	    return(count($ProcessState) >= 2);
   	}
   	function kill($PID)
	/**
	* Kill Application PID
	*
	* @param  unknown_type $PID
	* @return boolen
	*/
	{
       if($this->is_running($PID)){
           exec("kill -KILL $PID");
           return true;
       }else return false;
   	}
}
?>